// HelloWin32.cpp
// compile with: /D_UNICODE /DUNICODE /DWIN32 /D_WINDOWS /c

#include <windows.h>	// Search along the path.
#include <stdlib.h>		// Search along the path.
#include <tchar.h>		// Search along the path.
#include <stdio.h>		// Search along the path.

#include <iostream>		// Search along the path.
#include <string.h>		// Search along the path.
using namespace std;

#include "zTrace.h"		// Search in the same directory of the current file.
#include "WinLIFT.h"	// Search in the same directory of the current file.

// Global variables
HINSTANCE g_hInst;		// Current instance

// Declaration of the functions being used in this module:
//INT_PTR CALLBACK About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
string FullExeName();
string ExePath();

int WINAPI wWinMain(HINSTANCE hInstance, 
                    HINSTANCE hPrevInstance, 
                    LPTSTR lpCmdLine, 
                    int nCmdShow)
{
    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);

    // Declaration of local variables
    MSG msg;
    int nRet = 0;
    int IsInitialized = 0;
    WNDCLASSEX wcx;
	TCHAR szWindowClass[] = _T("win32app");
	TCHAR szTitle[] = _T("Win32 Guided Tour Application");

    // Register the main window class
    wcx.cbSize = sizeof(WNDCLASSEX);
    IsInitialized = GetClassInfoEx(hInstance, szWindowClass, &wcx);
    if (!IsInitialized)
    {
        wcx.style         = CS_HREDRAW | CS_VREDRAW;
        wcx.lpfnWndProc   = WndProc;
        wcx.cbClsExtra    = 0;
        wcx.cbWndExtra    = 0;
        wcx.hInstance     = hInstance;
        wcx.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
        wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wcx.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
        wcx.lpszMenuName  = NULL;
        wcx.lpszClassName = szWindowClass;
        wcx.hIconSm       = LoadIcon(wcx.hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
        if (RegisterClassEx(&wcx))
        {
           IsInitialized = -1;
        }
     }

     if (IsInitialized)
     {
        g_hInst = hInstance; // Stocke le handle d'instance dans la variable globale
    

		int x = max((GetSystemMetrics(SM_CXSCREEN) - 640) / 2, 0);
        int y = max((GetSystemMetrics(SM_CYSCREEN) - 480) / 2, 0);

        HWND hWnd = CreateWindowEx(
                    0,                              // Optional window styles.
                    szWindowClass,                  // Window class
                    szTitle,                        // Window text
                    WS_OVERLAPPEDWINDOW,            // Window style
    
                    // Size and position
                    x, y, 640, 480,
    
                    NULL,       // Parent window    
                    NULL,       // Menu
                    hInstance,  // Instance handle
                    NULL        // Additional application data
                    );
    
        if (hWnd)
        {

			//char szMsg[] = "hello";
			//zTrace(szMsg);

			//string Msg = "Window";
			//char szStr[12];
			//sprintf_s(szStr, "% d ", hWnd);
			//Msg += szStr;
			//zTrace(Msg);

			//char exepath[MAX_PATH]; 
			//int LenExeName = GetModuleFileNameA(0, exepath, sizeof(exepath)); 
			//zTrace(exepath);

			string SkinTheme = ExePath();
			SkinTheme += "Sony.sks";
			if (skInitEngine (SkinTheme, ""))
			{
				skSkinWindow(hWnd, "Dock|Undock|Minimize|Maximize|Restore|Close");
			}

            ShowWindow(hWnd, nCmdShow);
            UpdateWindow(hWnd);
    
            // Main message loop
            while (GetMessage(&msg, NULL, 0, 0))
            {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
            nRet = msg.wParam;
        }
     }
    
     return nRet;
}

// Main winproc
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

    switch (uMsg)
    {
    case WM_COMMAND:
         wmId    = LOWORD(wParam);
         wmEvent = HIWORD(wParam);
         // Process menu command
         //switch (wmId)
         //{
         //case IDM_ABOUT:
         //     DialogBox(g_hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
         //     break;
         //case IDM_EXIT:
         //     DestroyWindow(hWnd);
         //     break;
         //}
         return 0;
    case WM_PAINT:
         hdc = BeginPaint(hWnd, &ps);
         // TODO: process here the WM_PAINT message...
         EndPaint(hWnd, &ps);
         return 0;
    case WM_DESTROY:
         PostQuitMessage(0);
         return 0;
    }
   
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}  

string FullExeName()
{
	string sResult;
	char exepath[MAX_PATH]; 
	if (GetModuleFileNameA(0, exepath, sizeof(exepath)))
	{
		sResult = exepath;
	}
	return sResult;
}

string ExePath()
{
	string sResult;
	char exepath[MAX_PATH]; 
	if (GetModuleFileNameA(0, exepath, sizeof(exepath)))
	{
		sResult = exepath;
		sResult = sResult.substr( 0, sResult.rfind("\\"));
		sResult += "\\";
	}
	return sResult;
}

//// The about dialog function
//INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
//{
//    UNREFERENCED_PARAMETER(lParam);
//    switch (message)
//    {
//    case WM_INITDIALOG:
//         return (INT_PTR)TRUE;
//
//    case WM_COMMAND:
//         if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
//         {
//            EndDialog(hDlg, LOWORD(wParam));
//            return (INT_PTR)TRUE;
//         }
//         break;
//    }
//    return (INT_PTR)FALSE;
//}

